Subject: Re: endian

From: Andreas Busse <[email-masked]>
Date: Fri, 25 Jun 93 08:56:24 +0200

> I favor big endian for the mips project for two reasons:
>
> 1. Binary compatibility hacks with other Mips systems will be
>    impossible or incredibly difficult otherwise.
> 
> 2. It would be a very good idea to leverege off the architectural independence
>    work of the 68000 port.  I am not talking about a port of their port, rather
>    that we work in tandem with them in building a portable linux source tree.
>    And the neat thing is, they're allready dealing with the little-big-endian 
>    issue.
> 
> 3. I like big-endian.  (Not a reason.  A bias.)

I totally agree !

> The problem I see is with interfacing with the ISA bus.  The software will have to know how to
> deal with the endianness, or there will have to be a hardware swap.
> Does the nifty bus controller already deal with that?
> How much more difficult would this make writing device drivers?

What ISA-bus-cards do we need ? Perhaps some more serial lines,
a fax-modem or the like. Most of them are 8-bit, so where is the
byte-swapping problem ?

> If SCSI, ethernet and video are on the motherboard, I think that we don't need to invent
> another super-nifty multi-cool expansion slot system. 

Right.

> a) that is hard
> b) we probably wouldn't get it right the first time
> c) most of the fast stuff is already on the motherboard

> I agree that an ISA bus would be neat and allow us to put lots of 
> clone cards in the system, but I could live even without this.

Right too.

> However, I feel that we should run every line going to the cpu also
> to some sort of connector.  Just one.  A bunch of other signals can
> go to/come from this slot, but the important thing is to allow
> someone else, later, to put a daughter card there that perhaps 
> can do the nifty bus stuff, or whatever.

That might lead us into heavy-duty timing problems. I would not
do that since nobody knows what kind of daughterboards we might need.

> Perhaps someone would like to make an AXP daughtercard.  Or a 486 card to allow
> running of Linux binaries.  Make it simple.  Don't worry about
> how others might use it.  And the great thing is, it is just
> the cost of a (perhaps very big) connector.  Cheap.  Which I 
> appreciate.

Too much overhead. And big connectors aren't cheap !
We would have to guarantee timings, signal delays, driver fan outs
and so on, or third-party add-on cards may run on one one board
but not on others.
What do we want to have ? A low-cost/high-speed workstation or a
multi-cpu/multi-architecture dinosaur ?

Bye,
Andy

-------------------------------------------------------------------------------
Waldorf Electronics GmbH, R&D Department
c/o Andreas Busse
Neustrasse 9-12
D-5481 Waldorf
Phone:  +49 (0)2636-80294
Fax:    +49 (0)2636-80188
e-mail: [email-masked]
-------------------------------------------------------------------------------